"use strict";

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _codemirror = _interopRequireDefault(require("codemirror"));

var DiffMatchPatch = _interopRequireWildcard(require("diff-match-patch"));

var MergeViewCodeMirror = _interopRequireWildcard(require("../merge/merge"));

require("../css/merge.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const MergeLang = props => {
  const data = props.data;
  const refCode = (0, _react.useRef)(null);
  let mode;

  if (data.modeMerge === 'json') {
    mode = {
      name: "javascript",
      json: true,
      statementIndent: 2
    };
  } else {
    mode = data.modeMerge;
  }

  (0, _react.useEffect)(() => {
    MergeViewCodeMirror.init(_codemirror.default, DiffMatchPatch);

    _codemirror.default.MergeView(refCode.current, {
      value: data.value,
      origLeft: null,
      origRight: data.origRight,
      lineNumbers: true,
      tabSize: 2,
      lineWrapping: true,
      readOnly: data.readOnly ? data.readOnly : false,
      collapseIdentical: true,
      revertButtons: false,
      styleActiveLine: true,
      highlightDifferences: true,
      mode: mode ? mode : null
    });

    return () => {
      const elem = refCode.current;

      if (elem.firstChild) {
        elem.firstChild.remove();
      }
    };
  }, [props]);
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: refCode,
    className: data.class ? data.class : null
  });
};

var _default = MergeLang;
exports.default = _default;